/***********************************************
 * VS1011E Cu
 *
 **********************************************/
#include "VS1011.h"

/********************************
 * R}ho͊֐
 *********************************/
void Command(uint8_t RegAdrs, uint8_t Upper, uint8_t Lower){
    uint8_t cbuf[4];
    cbuf[0] = 0x02;             // Commabd Write
    cbuf[1] = RegAdrs;          // Set Data
    cbuf[2] = Upper;
    cbuf[3] = Lower;
    XDCS_Set();                 // Command Mode
    XCS_Clear();                // CS Low
    SERCOM1_SPI_Write(cbuf, 4); // Send Command
    XCS_Set();                  // CS High 
    while(DREQ_Get() == 0);
}
/**********************************
 * mFtR}ho͊֐
 *********************************/
void CmdCheck(uint8_t RegAdrs, uint8_t Upper, uint8_t Lower){
    uint8_t cbuf[4], rbuf[4];
    do{
        cbuf[0] = 0x02;             // Commabd Write
        cbuf[1] = RegAdrs;          // Set Data
        cbuf[2] = Upper;
        cbuf[3] = Lower;
        XDCS_Set();                 // Command Mode
        XCS_Clear();                // CS Low
        SERCOM1_SPI_Write(cbuf, 4); // Send Command
        XCS_Set();                  // CS High
        // check
        cbuf[0] = 0x03;             // Read
        cbuf[1] = RegAdrs;
        while(DREQ_Get() == 0);
        XCS_Clear();
        SERCOM1_SPI_WriteRead(cbuf, 2, rbuf, 4);
        XCS_Set();
    }while((rbuf[2] != cbuf[2]) || (rbuf[3] != cbuf[3]));
}
/*********************************
 * VS1011 f[^o͊֐
 ********************************/
void SendData(uint8_t data){
    uint8_t dbuf[2]; 

    dbuf[0] = data;
    while(DREQ_Get() == 0);
    SERCOM1_SPI_Write(dbuf, 1);
}
/**********************************
 * VS1011֐
 **********************************/
void VS1011_Init(void){
//    uint16_t val;
    
    XDCS_Set();
    XCS_Set();
    XRST_Clear();
    Delay_ms(50);
    XRST_Set();
    Delay_ms(10);
    // set mode
    CmdCheck(0x00, 0x08, 0x20);     // New Mode SDI Test
    // Clock doubler
//    val = 12288 / 2 + 0x8000;
//    CmdCheck(0x03, (uint8_t)(val>>8), (uint8_t)(val&0xFF));
//    CmdCheck(0x03, 0x98, 0x00);
    Delay_ms(10);
}
/************************************
 * go̓[h
 * Mode = SPI Test
 ***********************************/
void VS1011_SineTest(void){
    uint8_t dbuf[8] = {0x53,0xEF,0x6E,0x7D,0x00,0x00,0x00,0x00};
    
    while(DREQ_Get() == 0);
    XDCS_Clear();
    SERCOM1_SPI_Write(dbuf, 8);
    XDCS_Set();
}
/***********************************************
*  ʃxݒ֐
*   vRight = E`lp
*   vLeft  = `lp
*@@   @0x00=Max 0dB 0.5dBXebvŉ
************************************************/
void SetVolume(uint8_t vRight, uint8_t vLeft){
	Command(0x0B, vRight, vLeft);
}
/**********************************************
*  ቹu[Xgݒ萧֐
*    bassF ቹQC@W0dB15dB͈̔
*    gfreq: ቹu[Xggݒ@10HzXebv@0to15͈̔
***********************************************/
void SetBassBoost(uint8_t bass, uint8_t gfreq)
{
	uint8_t temp1 = 0;
	/* ݒ͈͂̐ */
	if(bass > 15)
		bass = 15;
	if(gfreq > 15)
		gfreq = 15;
	/* 8rbgɍ */
	temp1 = gfreq;
	temp1 |= (bass << 4);
	Command(0x02, 0x0F, temp1);		// BASS	
}
/**********************************************
*  ݒ萧֐
*    bassF ቹx@W0dB15dB͈̔
*    gfreq: ቹgݒ@10HzXebv@0?15͈̔
*@@trebF x
*    tfreqFgݒ@1kHzXebv
***********************************************/
void SetBoost(uint8_t bass, uint8_t gfreq, uint8_t treb, uint8_t tfreq)
{
	uint8_t temp1 = 0;
	uint8_t temp2 = 0;
	/* ݒ͈͂̐ */
	if(bass > 15)
		bass = 15;
	if(gfreq > 15)
		gfreq = 15;
	/* 8rbgɍ */
	temp1 = gfreq;
	temp1 |= (bass << 4);
	if(treb > 15)
		treb = 15;
	if(tfreq > 15)
		tfreq = 15;
	temp2 = tfreq;
	temp2 |= (treb << 4);
	Command(0x02, temp2, temp1);	
}
/*********************************************
*	ĐI֐
*   obt@ɎcĂf[^|o
*********************************************/
void PlayEnd(void){
	uint16_t i;

	/* Đobt@NÂ2048oCgM@*/
	XDCS_Clear();						// XDCSI
	for(i=0; i<2048; i++)
		SendData(0);					// 0̃f[^AM
	XDCS_Set();                         // XDCSIt
	/*** \tgEFAZbgŊ **/
	Command(0x00, 0x08, 0x24);			// SM_RESETM
	while(DREQ_Get() == 0);				// R}h҂
}
